require("standard")
_VADRESSE = 0.33
ad = {}

ad.libs = loadLib({"luaWidget","libClavier"})

dofile("Clavier.lua")

if(_VDBUS ~= nil) then
	ad.dbus = true
end

libClavier.activeScreen(clav,true)

ad.liste = {}
ad.liste[1] = {"Nom","Prnom","Tlphone"}
-- ad.liste[2] = {"","",""}
ad.color = {}
ad.color.blue = Color.new(10,10,31)
ad.color.noir = Color.new(0,0,0)
ad.color.jaune = Color.new(31,31,16)
ad.color.vertc = Color.new(10,29,18)

--****************************************
--Fenetre principale
--****************************************
fenP = {}
fenP.parent = luaWidget.newWidget(SCREEN_DOWN)
ad.tt = {"..","AB","CD","EF","GH","IJ","KL","MN","OP","QR","ST","UV","WX","YZ"}
for i= 1,14 do
	fenP[i] = luaWidget.newObj(fenP.parent,TBUTTON,2+((i-1)*18),0,18,15,ad.tt[i],_ACENTER)
end
luaWidget.set(fenP.parent,fenP[1],"check",true)
fenP.liste = luaWidget.newObj(fenP.parent,TTABLEVIEW,0,16,256,156,ad.liste)
fenP.bModif = luaWidget.newObj(fenP.parent,TBUTTON,70,175,60,15,"Modifier",_ACENTER)
fenP.bNouv = luaWidget.newObj(fenP.parent,TBUTTON,2,175,60,15,"Nouveau",_ACENTER)
fenP.bQuit = luaWidget.newObj(fenP.parent,TBUTTON,194,175,60,15,"Quitter",_ACENTER)

--****************************************
--Fenetre d'ajout / modification d'adresse
--****************************************
fenN = {}
fenN.parent = luaWidget.newWidget(SCREEN_DOWN)
fenN[1] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,10,130,15)
fenN[2] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,30,130,15)
fenN[3] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,50,130,15)
fenN[4] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,70,130,15)
fenN[5] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,90,130,15)
fenN[6] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,110,130,15)
fenN[7] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,130,40,15)
fenN[8] = luaWidget.newObj(fenN.parent,TTEXTBOX,100,150,130,15)
fenN.bOk = luaWidget.newObj(fenN.parent,TBUTTON,100,170,60,15,"OK",_ACENTER)
fenN.bNo = luaWidget.newObj(fenN.parent,TBUTTON,170,170,60,15,"Annuler",_ACENTER)
fenN.bSup = luaWidget.newObj(fenN.parent,TBUTTON,10,170,70,15,"Supprimer",_ACENTER)
fenN[9] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,10,90,15,"Nom :",_ARIGHT)
fenN[10] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,30,90,15,"Prnom :",_ARIGHT)
fenN[11] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,50,90,15,"Tel1 :",_ARIGHT)
fenN[12] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,70,90,15,"Tel2 :",_ARIGHT)
fenN[13] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,90,90,15,"E-Mail :",_ARIGHT)
fenN[14] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,110,90,15,"Adresse :",_ARIGHT)
fenN[15] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,130,90,15,"Code Postal :",_ARIGHT)
fenN[16] = luaWidget.newObj(fenN.parent,TTEXTBOX,8,150,90,15,"Ville :",_ARIGHT)
for i = 9,16 do
	luaWidget.set(fenN.parent,fenN[i],"cText",coul.blanc)
	luaWidget.set(fenN.parent,fenN[i],"cFond",coul.noir)
end

--****************************************
--Fenetre popUp
--****************************************
fenPop = {}
fenPop.parent = luaWidget.newWidget(SCREEN_DOWN)
fenPop.titre = luaWidget.newObj(fenPop.parent,TTEXTBOX,10,80,236,15,"Titre",_ALEFT)
fenPop.texte = luaWidget.newObj(fenPop.parent,TTEXTBOX,10,95,236,15,"Texte",_ACENTER)
fenPop.bOk = luaWidget.newObj(fenPop.parent,TBUTTON,60,115,60,15,"Oui",_ACENTER)
fenPop.bNo = luaWidget.newObj(fenPop.parent,TBUTTON,120,115,60,15,"Non",_ACENTER)
fenPop.bCa = luaWidget.newObj(fenPop.parent,TBUTTON,180,115,60,15,"Annuler",_ACENTER)
luaWidget.set(fenPop.parent,fenPop.titre,"cFond",ad.color.blue)
luaWidget.set(fenPop.parent,fenPop.titre,"cCadre",ad.color.blue)
luaWidget.set(fenPop.parent,fenPop.texte,"cFond",ad.color.jaune)
luaWidget.set(fenPop.parent,fenPop.texte,"cCadre",ad.color.jaune)

ad.popUp = {}
ad.popUp.create = function(titre,texte,bok,bno,bca)
	local numB = 0
	local xx = 98
	ad.pUp = true
	luaWidget.set(fenPop.parent,fenPop.titre,"text",titre)
	luaWidget.set(fenPop.parent,fenPop.texte,"text",texte)
	if(bok ~= nil) then if(bok) then numB = numB +1 end else bok = false end
	if(bno ~= nil) then if(bno) then numB = numB +1 end else bno = false end
	if(bca ~= nil) then if(bca) then numB = numB +1 end else bca = false end
	if(numB == 0) then 
		luaWidget.set(fenPop.parent,fenPop.bNo,"visible",false)
		luaWidget.set(fenPop.parent,fenPop.bCa,"visible",false)
		luaWidget.set(fenPop.parent,fenPop.bOk,"x",96)	
	else
		xx = 128-(numB*32)
		luaWidget.set(fenPop.parent,fenPop.bOk,"visible",bok)
		luaWidget.set(fenPop.parent,fenPop.bNo,"visible",bno)
		luaWidget.set(fenPop.parent,fenPop.bCa,"visible",bca)
		if(bok) then luaWidget.set(fenPop.parent,fenPop.bOk,"x",xx) xx = xx + 64 end
		if(bno) then luaWidget.set(fenPop.parent,fenPop.bNo,"x",xx) xx = xx + 64 end
		if(bca) then luaWidget.set(fenPop.parent,fenPop.bCa,"x",xx) xx = xx + 64 end
	end
end

ad.popUp.show = function()
	screen.drawFillRect(SCREEN_DOWN,9,79,247,132,ad.color.jaune)
	luaWidget.show(fenPop.parent)
end

ad.popUp.held = function()
	local rep = 0
	luaWidget.held(fenPop.parent)
	if(luaWidget.get(fenPop.parent,fenPop.bOk,"check"))then
		luaWidget.set(fenPop.parent,fenPop.bOk,"check",false)
		rep = 1
	end
	if(luaWidget.get(fenPop.parent,fenPop.bNo,"check"))then
		luaWidget.set(fenPop.parent,fenPop.bNo,"check",false)
		rep = 2
	end
	if(luaWidget.get(fenPop.parent,fenPop.bCa,"check"))then
		luaWidget.set(fenPop.parent,fenPop.bCa,"check",false)
		rep = 3
	end
	return rep
end

ad.desBon = function(x,y)
	local brun = Color.new(15,8,0)
	local chair = Color.new(31,16,16)
	local bleu = Color.new(0,0,31)
	screen.drawLine(SCREEN_UP,x+3,y+1,x+8,y+1,brun)
	screen.drawLine(SCREEN_UP,x+2,y+2,x+9,y+2,brun)
	screen.drawLine(SCREEN_UP,x+1,y+3,x+10,y+3,brun)
	screen.drawLine(SCREEN_UP,x+1,y+4,x+10,y+4,brun)
	screen.drawLine(SCREEN_UP,x+1,y+5,x+10,y+5,brun)
	screen.drawLine(SCREEN_UP,x+2,y+4,x+9,y+4,chair)
	screen.drawLine(SCREEN_UP,x+2,y+5,x+9,y+5,chair)
	screen.drawLine(SCREEN_UP,x+1,y+6,x+10,y+6,chair)
	screen.drawLine(SCREEN_UP,x+1,y+7,x+10,y+7,chair)
	screen.drawLine(SCREEN_UP,x+1,y+8,x+10,y+8,chair)
	screen.drawLine(SCREEN_UP,x+1,y+9,x+10,y+9,bleu)
	screen.drawLine(SCREEN_UP,x+2,y+9,x+9,y+9,chair)
	screen.drawLine(SCREEN_UP,x,y+10,x+11,y+10,bleu)
	screen.drawLine(SCREEN_UP,x,y+11,x+11,y+11,bleu)
	screen.drawLine(SCREEN_UP,x,y+12,x+11,y+12,bleu)
end

ad.desTel = function(x,y)
	local rouge = Color.new(31,0,0)
	local bleu = Color.new(16,31,31)
	screen.drawFillRect(SCREEN_UP,x+1,y+1,x+10,y+13,rouge)
	screen.drawLine(SCREEN_UP,x+2,y,x+9,y,rouge)
	screen.drawFillRect(SCREEN_UP,x+2,y+3,x+4,y+6,bleu)
	screen.drawFillRect(SCREEN_UP,x+6,y+3,x+8,y+6,bleu)
	screen.drawFillRect(SCREEN_UP,x+2,y+8,x+4,y+11,bleu)
	screen.drawFillRect(SCREEN_UP,x+6,y+8,x+8,y+11,bleu)
end

ad.desMai = function(x,y)
	local rouge = Color.new(31,16,0)
	local gris = Color.new(16,16,16)
	screen.drawLine(SCREEN_UP,x+3,y+1,x+8,y+1,rouge)
	screen.drawLine(SCREEN_UP,x+2,y+2,x+9,y+2,rouge)
	screen.drawLine(SCREEN_UP,x+1,y+3,x+10,y+3,rouge)
	screen.drawLine(SCREEN_UP,x,y+4,x+11,y+4,rouge)
	screen.drawFillRect(SCREEN_UP,x+2,y+5,x+9,y+12,gris)
end

ad.carteVisi = function(x,y,ll)
	screen.drawFillRect(SCREEN_UP,x+1,y+10,x+199,y+89,ad.color.jaune)
	screen.drawFillRect(SCREEN_UP,x+1,y+1,x+99,y+10,ad.color.jaune)
	screen.print(SCREEN_UP,x+84,y+2,ad.tt[ad.filtre+1],ad.color.noir)
	screen.drawLine(SCREEN_UP,x+1,y,x+99,y,ad.color.vertc)
	screen.drawLine(SCREEN_UP,x+99,y+1,x+99,y+9,ad.color.vertc)
	screen.drawLine(SCREEN_UP,x+99,y+9,x+199,y+9,ad.color.vertc)
	screen.drawLine(SCREEN_UP,x+199,y+10,x+199,y+89,ad.color.vertc)
	screen.drawLine(SCREEN_UP,x+1,y+89,x+199,y+89,ad.color.vertc)
	screen.drawLine(SCREEN_UP,x,y+1,x,y+89,ad.color.vertc)
	ad.desBon(x+4,y+14)
	ad.desTel(x+4,y+38)
	ad.desMai(x+4,y+70)
	if(ll ~= nil) then
		screen.print(SCREEN_UP,x+20,y+16,ll[1].." "..ll[2],ad.color.noir)
		screen.print(SCREEN_UP,x+20,y+36,"Tel1: "..ll[3],ad.color.noir)
		screen.print(SCREEN_UP,x+20,y+45,"Tel2: "..ll[4],ad.color.noir)
		screen.print(SCREEN_UP,x+20,y+58,ll[5],ad.color.noir)
		screen.print(SCREEN_UP,x+20,y+70,ll[6],ad.color.noir)
		screen.print(SCREEN_UP,x+20,y+79,ll[7].." "..ll[8],ad.color.noir)
	end
end

ad.enreg = function()
	local fich = io.open("carnet.ad","wt")
	local i,j
	for i = 1, #ad.liste do
		for j=1,8 do
			fich:write(ad.liste[i][j]..",")
		end
		fich:write("\n")
	end
	io.close(fich)
end

ad.ouvre = function()
	local fich = io.open("carnet.ad","rt")
	local i, buff, k, l
	if(fich) then
		buff = fich:read("*l")
		while(buff ~= nil) do
			local ll = {}
			k,l = string.find(buff,",")
			ll[1] = string.sub(buff,1,k-1)
			buff = string.sub(buff,l+1)
			for i=1,6 do
				k,l = string.find(buff,",")
				ll[i+1] = string.sub(buff,1,k-1)
				buff = string.sub(buff,l+1)
			end
			k,l = string.find(buff,",")
			ll[8] = string.sub(buff,1,k-1)
			table.insert(ad.liste,ll)
			luaWidget.addElement(fenP.parent,fenP.liste,{ll[1],ll[2],ll[3]})
			buff = fich:read("*l")
		end		
		io.close(fich)
	end
end

ad.setToGListe = function()
	local ll = {}
	table.insert(ll,{"Nom","Prnom","Tlphone"})
	local i,buff,a,b,c
	local ldep = 0
	a = string.sub(ad.tt[ad.filtre+1],1,1)
	b = string.sub(ad.tt[ad.filtre+1],-1)
	for i = 1,#ad.liste do
		buff = {ad.liste[i][1],ad.liste[i][2],ad.liste[i][3]}
		if(ad.filtre == 0) then 
			table.insert(ll,buff)
			if(ldep == 0) then ldep = i end
		else
			c = string.sub(buff[1],1,1)
			if(c == a or c == b)then
				if(ldep == 0) then ldep = i end
				table.insert(ll,buff)
			end
		end
	end
	luaWidget.set(fenP.parent,fenP.liste,"element",ll)
	ad.ldep = ldep
end

ad.retPos = function(texte)
	local i
	for i=1,#ad.liste do
		if(ad.liste[i][1]..ad.liste[i][2] > texte) then return i end
	end
	return 0
end

ad.setFiltre = function()
	local i
	if(Stylus.newPress and Stylus.Y < 15) then
		for i = 1,#ad.tt do
			luaWidget.set(fenP.parent,fenP[i],"check",false)
		end
		luaWidget.held(fenP.parent)
		for i = 1,#ad.tt do
			if(luaWidget.get(fenP.parent,fenP[i],"check")) then ad.filtre = i-1 end
		end
		ad.setToGListe()
	end
end

ad.quit = false
ad.pUp = false
ad.rpUp = 0
ad.fen_active = fenP.parent
ad.showClav = false
ad.tou = ""
ad.entrer = 0
ad.ancienY = 0
ad.liste = nil
ad.liste = {}
ad.filtre = 0
ad.action = 0
ad.date = DateTime.new()
ad.buff = ""
ad.ldep = 1
ad.ouvre()
luaWidget.setSel(fenP.parent,fenP.liste,1)

Debug.ON()
Debug.setColor(Color.new(31,0,0))

while not ad.quit do
	Controls.read()
	luaWidget.show(ad.fen_active)
	if(ad.pUp) then
		local rep
		ad.popUp.show() -- Est-ce que l'on supprime?
		rep = ad.popUp.held()
		if(rep > 0) then
			ad.pUp = false
			if(rep == 1) then -- Oui on supprime
				table.remove(ad.liste,position)
				ad.setToGListe()
				ad.enreg()
				ad.fen_active = fenP.parent
				ad.action = 0
			--elseif(rep == 2) then -- Non on ne supprime pas
				-- Bah rien alors
			end
		end
	else
		luaWidget.held(ad.fen_active)
		if(ad.action == 0) then ad.setFiltre() end
	end
	if(luaWidget.get(fenP.parent,fenP.bNouv,"check")) then
		luaWidget.set(fenP.parent,fenP.bNouv,"check",false)
		luaWidget.set(fenN.parent,fenN.bSup,"visible",false)
		ad.fen_active = fenN.parent
		for i= 1,8 do
			luaWidget.set(fenN.parent,fenN[i],"text","")
		end
		ad.action = 1
	end
	if(luaWidget.get(fenP.parent,fenP.bModif,"check")) then
		luaWidget.set(fenP.parent,fenP.bModif,"check",false)
		luaWidget.set(fenN.parent,fenN.bSup,"visible",true)
		position = (luaWidget.get(fenP.parent,fenP.liste,"pos")-1) + ad.ldep
		if(ad.liste[position] ~= nil) then
			for i= 1,8 do
				luaWidget.set(fenN.parent,fenN[i],"text",ad.liste[position][i])
			end
			ad.action = 2
			ad.fen_active = fenN.parent
		end
	end
	if(luaWidget.get(fenN.parent,fenN.bSup,"check")) then
		luaWidget.set(fenN.parent,fenN.bSup,"check",false)
		ad.popUp.create("Suppression contact","Voulez vous supprimer le contact ?",true,true,false)
		ad.pUp = true
	end
	if(luaWidget.get(fenN.parent,fenN.bNo,"check")) then
		luaWidget.set(fenN.parent,fenN.bNo,"check",false)
		ad.fen_active = fenP.parent
		ad.action = 0
	end
	if(luaWidget.get(fenP.parent,fenP.bQuit,"check")) then
		luaWidget.set(fenP.parent,fenP.bQuit,"check",false)
		ad.quit = true
	end
	if(luaWidget.get(fenN.parent,fenN.bOk,"check")) then
		luaWidget.set(fenN.parent,fenN.bOk,"check",false)
		ad.fen_active = fenP.parent
		local nom = luaWidget.get(fenN.parent,fenN[1],"text")
		local prenom = luaWidget.get(fenN.parent,fenN[2],"text")
		local tel = luaWidget.get(fenN.parent,fenN[3],"text")
		if(nom ~= "" or prenom ~= "" or tel ~= "") then
			if(ad.action ~= 1) then
				table.remove(ad.liste,position)
			end
			local posi = ad.retPos(nom..prenom)
			if(posi == 0) then posi = #ad.liste+1 end
			table.insert(ad.liste,posi,{nom,prenom,tel,
				luaWidget.get(fenN.parent,fenN[4],"text"),luaWidget.get(fenN.parent,fenN[5],"text"),
				luaWidget.get(fenN.parent,fenN[6],"text"),luaWidget.get(fenN.parent,fenN[7],"text"),
				luaWidget.get(fenN.parent,fenN[8],"text")})
			--tri
			ad.setToGListe()
			ad.enreg()
		end
		ad.action = 0
	end
	if(ad.showClav) then
		libClavier.show(clav)
		if(Stylus.newPress) then ad.tou = libClavier.held(clav,Stylus.X,Stylus.Y) end
	end
	if(ad.entrer == 0) then
		for i = 1,8 do
			if(luaWidget.get(fenN.parent,fenN[i],"check")) then 
				ad.entrer = i 
				if(i == 3 or i == 4 or i == 7) then libClavier.activePanel(clav,4)
				elseif(i == 1) then libClavier.activePanel(clav,2)
				else libClavier.activePanel(clav,1) end
			end
		end
	else
		if(not ad.showClav) then
			libClavier.setText(clav,luaWidget.get(fenN.parent,fenN[ad.entrer],"text"))
			ad.showClav = true
			for i= 1,8 do
				if(i ~= ad.entrer) then 
					luaWidget.set(fenN.parent,fenN[i+8],"visible",false) 
				end
				luaWidget.set(fenN.parent,fenN[i],"visible",false)
			end
			ad.ancienY = luaWidget.get(fenN.parent,fenN[ad.entrer],"y")
			luaWidget.set(fenN.parent,fenN[ad.entrer+8],"align",_ALEFT)
			luaWidget.set(fenN.parent,fenN[ad.entrer+8],"y",45)
			luaWidget.set(fenN.parent,fenN.bOk,"visible",false)
			luaWidget.set(fenN.parent,fenN.bNo,"visible",false)
			if(ad.action == 2) then luaWidget.set(fenN.parent,fenN.bSup,"visible",false) end
		else
			if(ad.tou == "Enter" or ad.tou == "Esc") then
				if(ad.tou == "Enter") then 
					local buff = libClavier.getText(clav)
					if(ad.entrer == 1) then buff = string.upper(buff)
					elseif(ad.entrer == 2) then 
						buff = string.upper(string.sub(buff,1,1))..string.lower(string.sub(buff,2))
					end
					luaWidget.set(fenN.parent,fenN[ad.entrer],"text",buff)
				end
				luaWidget.set(fenN.parent,fenN[ad.entrer],"check",false)
				ad.showClav = false
				ad.tou = ""
				for i= 1,8 do
					if(i ~= ad.entrer) then 
						luaWidget.set(fenN.parent,fenN[i+8],"visible",true) 
					end
					luaWidget.set(fenN.parent,fenN[i],"visible",true)
				end
				luaWidget.set(fenN.parent,fenN[ad.entrer+8],"align",_ARIGHT)
				luaWidget.set(fenN.parent,fenN[ad.entrer+8],"y",ad.ancienY)
				luaWidget.set(fenN.parent,fenN.bOk,"visible",true)
				luaWidget.set(fenN.parent,fenN.bNo,"visible",true)
				if(ad.action == 2) then luaWidget.set(fenN.parent,fenN.bSup,"visible",true) end
				ad.entrer = 0
			end
		end
	end
	if(ad.action == 0) then
		position = (luaWidget.get(fenP.parent,fenP.liste,"pos")-1) + ad.ldep
		ad.carteVisi(28,60,ad.liste[position])
	elseif(ad.action == 1 or ad.action == 2) then
		ad.carteVisi(28,60,{luaWidget.get(fenN.parent,fenN[1],"text"),luaWidget.get(fenN.parent,fenN[2],"text"),
				luaWidget.get(fenN.parent,fenN[3],"text"),luaWidget.get(fenN.parent,fenN[4],"text"),
				luaWidget.get(fenN.parent,fenN[5],"text"),luaWidget.get(fenN.parent,fenN[6],"text"),
				luaWidget.get(fenN.parent,fenN[7],"text"),luaWidget.get(fenN.parent,fenN[8],"text")})
	end
	screen.print(SCREEN_UP,59,27,"CARNET D'ADRESSES V".._VADRESSE)
	ad.date = DateTime.getCurrentTime()
	ad.buff = string.format("%02d/%02d/%04d",ad.date.day,ad.date.month,ad.date.year)
	screen.drawFillRect(SCREEN_UP,1,1,68,15,ad.color.jaune)
	screen.drawRect(SCREEN_UP,1,1,68,15,ad.color.vertc)
	screen.print(SCREEN_UP,4,4,ad.buff,ad.color.noir)
	ad.buff = string.format("%02d:%02d:%02d",ad.date.hour,ad.date.minute,ad.date.second)
	screen.drawFillRect(SCREEN_UP,199,1,255,15,ad.color.jaune)
	screen.drawRect(SCREEN_UP,199,1,255,15,ad.color.vertc)
	screen.print(SCREEN_UP,202,4,ad.buff,ad.color.noir)
	screen.print(SCREEN_UP,170,181,"by PAPY (2010)")
	render()
end

--*************************************
--* Si _VDBUS existe alors on envois un message 
--* comportant nom, prenom, tel1, tel2, adresse
--*************************************
if(ad.dbus) then
	local buff = {}
	buff.nom = ad.liste[position][1]
	buff.prenom = ad.liste[position][2]
	buff.tel1 = ad.liste[position][3]
	buff.tel2 = ad.liste[position][4]
	buff.email = ad.liste[position][5]
	buff.adr = ad.liste[position][6]
	buff.cp = ad.liste[position][7]
	buff.ville = ad.liste[position][8]
	DBus.newMess("cada",buff,2)
end

_VADRESSE = nil
luaWidget.del(fenP.parent)
luaWidget.del(fenN.parent)
luaWidget.del(fenPop.parent)
fenP = nil
fenN = nil
fenPop = nil
unloadLib(ad.libs)
delStandard()
position = nil
ad = nil
i = nil
